# -*- coding: UTF-8 -*-
import appModuleHandler
from NVDAObjects.IAccessible import IAccessible, getNVDAObjectFromEvent
import speech
import controlTypes
import ui
import shellapi
from logHandler import log
import winUser
import api
import scriptHandler
import braille
import eventHandler
import config
from ctypes import windll
import os
import winsound

currentFile = ""
classNasty = "TNASTYNAGSCREEN"
classNastyPanel = ""
classMyPanel = ""
classComboBox = ""
classTabControl = ""
backupMessageTimeout = None
speakList = []
brailleList = []

def texttoBrl(text):
  if text is None:
    return
  noMessageTimeout = True if 'noMessageTimeout' in config.conf["braille"] else False
  backupMessageTimeout = config.conf["braille"]["noMessageTimeout"]
  config.conf["braille"]["noMessageTimeout"] = True
  braille.handler.message(text)
  config.conf["braille"]["noMessageTimeout"] = backupMessageTimeout

  # if braille.handler.buffer is braille.handler.messageBuffer:
  #   braille.handler.buffer.clear()
  # else:
  #   braille.handler.buffer = braille.handler.messageBuffer
  # region = braille.TextRegion(text)
  # region.update()
  # braille.handler.buffer.regions.append(region)
  # braille.handler.buffer.update()
  # braille.handler.update()

class AppModule(appModuleHandler.AppModule):

  def __init__(self, *args, **kwargs):
    super(AppModule, self).__init__(*args, **kwargs)
    global classNastyPanel
    global classMyPanel
    global classComboBox
    global classTabControl
    global classPathPanel
    if (self.appName == "totalcmd64"):
      classNasty = "TNASTYNAGSCREEN"
      classNastyPanel = "Window"
      classMyPanel = "Window"
      classComboBox = "LCLComboBox"
      classTabControl = "SysTabControl32"
      classPathPanel = "TPathPanel"
    else:
      classNastyPanel = "TPanel"
      classMyPanel = "TMyPanel"
      classComboBox = "TMyComboBox"
      classTabControl = "TMyTabControl"
      classPathPanel = "TPathPanel"
    # braille.handler.setTether(braille.handler.TETHER_REVIEW)
    # braille.handler.initialDisplay()
    # braille.handler.update()
    
  def event_gainFocus(self, obj, nextHandler):
    if obj.windowClassName == classNasty:
      self.GetEntryNumber(obj)
    nextHandler()

  def chooseNVDAObjectOverlayClasses(self, obj, clsList):
    if obj.windowClassName in ("TMyListBox", "TMyListBox.UnicodeClass", "LCLListBox"):
      clsList.insert(0, TCList)
    if obj.windowClassName in ("ComboLBox"):
      clsList.insert(0, TCDriveList)

  def GetEntryNumber(self,obj):
    global classNastyPanel
    for child in obj.children[0].children[0].children[0].children:
      if (child.windowClassName == classNastyPanel):
        EntryNumber = child.name
        ui.message(u"stiskněte tlačítko: " + EntryNumber)
  
  def GetDevString(self, sDev):
    dict = {'': '', 
     '[-a-]': u"á", '[-b-]': u"bé", '[-c-]': u"cé", '[-d-]': u'dé', '[-e-]': u'é', '[-f-]': u'ef',
     '[-g-]': u'gé', '[-h-]': u'há', '[-i-]': u'í', '[-j-]': u'jé', '[-k-]': u'ká',
     '[-l-]': u'el', '[-m-]': u'em', '[-n-]': u'en', '[-o-]': u'ó', '[-p-]': u'pé',
     '[-q-]': u'kvé', '[-r-]': u'er', '[-s-]': u'es', '[-t-]': u'té', '[-u-]': u'ú',
     '[-v-]': u'vé', '[-w-]': u'dvojvé', '[-x-]': u'iks', '[-y-]': u'ypsilon', '[-z-]': u'zed',
     '[-\-]': u'zpětné lomítko',
     '[-+-]': u'plus'}
    if sDev in dict: sDev = dict[sDev]
    return "jednotka " + sDev
  
  def GetHeader(self, bLeft = True, bTop = True):
    # get combo : drive and path right of combo, 23 and 64bit, tab shown or closed
    global classMyPanel
    global classComboBox
    sDevName = ""
    sDevInfo = ""
    sInf1 = ""
    sInf2 = ""
    sInf3 = ""
    sInf4 = ""
    x1 = 0
    x2 = 0
    sOut = ""
    if (bLeft):
      sOut = ""
    else:
      sOut = ""

    obj = api.getForegroundObject()
    objName = obj.name
    win_width = obj.location[2]
    win_top = obj.location[1]
    win_bottom = obj.location[3]
    win_half = win_top + (win_bottom/2)

    for child in obj.children:
      if child.windowClassName == classMyPanel and obj.role == controlTypes.Role.PANE:
        
        #3 panels, usually: bottom(cmd combo), left, right
        #assume two panels side by side must fit in window, cmd panel is wide accross the window and does not pass this condition
        panel_width = child.location[2]
        panel_x = child.location[0]
        sDevName = ""
        sDevInfo = ""
        sSel = ""
        sPath = ""
        ComboY = 0
        ComboBottom = 0

        #one of two panels with list, excludes bottom panel
        if ((panel_width * 2) < win_width):
          IsPanelTabbed = False;
          for panel_child in child.children:
            sPanelChildName = ""
            if ((panel_child.name is None)==False):
              sPanelChildName = panel_child.name

            if panel_child.windowClassName == classComboBox: 
              if ((panel_child.value is None)==False):
                sPanelChildName = panel_child.value
                sDevName = sPanelChildName
                ComboY = panel_child.location[1]
                ComboBottom = ComboY + panel_child.location[3]
          
            #tab control does appear only if multiple tabs are defined, its text is not relevant
            if panel_child.windowClassName == classTabControl:
              IsPanelTabbed = True
              if (len(sPanelChildName) > 0):
                sPanelChildName = panel_child.name
              #examine tab, if tabbed, path and selection is here 
              for tab_child in panel_child.children:
                if ((tab_child.name is None)==False):
                  sTabChildName = tab_child.name
                  if (tab_child.windowClassName != classTabControl):
                    if (tab_child.location[1]>win_half):
                      sSel = sTabChildName
                    else:
                      sPath = sTabChildName

            if panel_child.windowClassName == classMyPanel:
              if (len(sPanelChildName) > 0):
                sDevInfo = sPanelChildName
                #panel has no tabs, get selection (at the bottom), get path (under combo)
                if (IsPanelTabbed == False):
                  if (panel_child.location[1] > win_half):
                    sSel = sPanelChildName
                  else:
                    #compare against combo bottom, must be totally under (avoid dev info, which is slightly under combo y)
                    if (panel_child.location[1] > ComboBottom):
                      sPath = sPanelChildName

            #panel has no tabs, 32bit
            if panel_child.windowClassName == classPathPanel: 
              sPath = sPanelChildName   

        if (len(sSel)>0):
          if u'Výběr' not in sSel: 
            sSel = u' ,výběr ' + sSel

        if (len(sDevName) and len(sDevInfo)):
          if (x1 == 0):
            x1 = panel_x
            sInf1 = self.GetDevString(sDevName) + " " + sDevInfo
            sInf3 = sPath + " " + sSel
          else:
            x2 = panel_x
            sInf2 = self.GetDevString(sDevName) + " " + sDevInfo
            sInf4 = sPath + " " + sSel

    if (bTop == False):
      sInf1 = sInf3
      sInf2 = sInf4

    if (bLeft):
      if (x1 < x2):
        sOut += sInf1
      else:
        sOut += sInf2
    else:
      if (x1 < x2):
        sOut += sInf2
      else:
        sOut += sInf1
    ui.message(sOut)


  #left/right (add keys mapping) 
  @scriptHandler.script(
    description=_(
      "Ohlásí stavový řádek pro jednotku v levém panelu."
    ),
    gesture="kb:control+alt+shift+Q"
  )

  def script_LeftStatus(self, gesture):
    self.GetHeader(True, False)

  @scriptHandler.script(
    description=_(
      "Ohlásí stavový řádek pro jednotku v pravém panelu."
    ),
    gesture="kb:control+alt+shift+W"
  )

  def script_RightStatus(self, gesture):
    self.GetHeader(False, False)

  @scriptHandler.script(
    description=_(
      "Ohlásí obsazené a volné místo na jednotce v levém panelu."
    ),
    gesture="kb:control+shift+Q"
  )

  def script_LeftDrive(self, gesture):
    self.GetHeader(True, True)

  @scriptHandler.script(
    description=_(
      "Ohlásí obsazené a volné místo na jednotce v pravém panelu."
    ),
    gesture="kb:control+shift+W"
  )

  def script_RightDrive(self, gesture):
    self.GetHeader(False, True)

  def getPanelPosition(self):
    user32 = windll.user32
    hnd = user32.GetForegroundWindow()
    curPanel = user32.SendMessageW(hnd, 1074, 1000, 0)
    if curPanel == 1:
      curPanelStr = "Vlevo."
    else:
      curPanelStr = "Vpravo."
    ui.message(curPanelStr)

  @scriptHandler.script(
    description=_(
      "Ohlásí pozici aktuálního panelu."
    ),
    gesture="kb:control+shift+O"
  )

  def script_PanelPosition(self, gesture):
    self.getPanelPosition()

  def getCurrentDir(self):
    user32 = windll.user32
    hnd = user32.GetForegroundWindow()
    panelHandle = user32.SendMessageW(hnd, 1074, 21, 0)
    return getNVDAObjectFromEvent(panelHandle, winUser.OBJID_CLIENT, 0).name[:-1]

  @scriptHandler.script(
    description=_(
      "Ohlásí cestu k aktuální složce. Po dvojitém stisku ji zkopíruje do schránky, po trojím stisku bude do schránky zkopírována cesta spolu s názvem aktuálně zvoleného souboru či složky."
    ),
    gesture="kb:control+shift+D"
  )

  def script_CurrentDir(self, gesture):
    global currentFile
    curPath = self.getCurrentDir()
    if scriptHandler.getLastScriptRepeatCount() == 1:
      api.copyToClip(curPath)
      ui.message("Složka do schránky " + curPath)
    elif scriptHandler.getLastScriptRepeatCount() == 2:
      curPathFile = os.path.join(curPath, currentFile)
      api.copyToClip(curPathFile)
      ui.message("Cesta do schránky " + curPathFile)
    
    else:
      ui.message(curPath)


class TCDriveList(IAccessible):

  def event_gainFocus(self):
    name = self.name
    description = self.displayText
    if description and name[:2] == "[-" and name[-2:] == "-]":
      self.name = description[0:1] + " (" + description[2:] + ")"
    super(TCDriveList,self).event_gainFocus()


class TCList(IAccessible):

  def reportFocus(self):
    # in case of two quick successive system focuses (e.g. after going one folder level up) only last focus is processed
    if eventHandler.isPendingEvents("gainFocus"):
      return
    obj = api.getForegroundObject()
    title = obj.name
    # list with search results is not processed
    if title == "Hledání souborů":
      super(TCList,self).reportFocus()
      return
    if self.name:
      global brailleList
      global speakList
      global currentFile
      if controlTypes.State.SELECTED in self.states:
        speakList.append(controlTypes.State.SELECTED.displayString)
      speakList.append(self.name.split("\\")[-1])
      speakList = list(dict.fromkeys(speakList))
      speech.speakMessage(" ".join(speakList))
      brailleList = brailleList + speakList
      brailleList = list(dict.fromkeys(brailleList))
      #texttoBrl(" ".join(brailleList))
      speakList.clear()
      brailleList.clear()
      currentFile = self.name.split("\\")[-1]
    else:
      super(TCList,self).reportFocus()

  def event_stateChange(self):
    obj = api.getForegroundObject()
    title = obj.name
    # list with search results is not processed
    if title == "Hledání souborů":
      super(TCList,self).reportFocus()
      return
    if self.name:
      states=self.states
      global brailleList
      if controlTypes.State.SELECTED in states:
        brailleList.append(controlTypes.State.SELECTED.displayString)
      brailleList.append(self.name.split("\\")[-1])
      #texttoBrl(" ".join(brailleList))
      brailleList.clear()
    else:
      super(TCList,self).reportFocus()

  def event_focusEntered(self):
    global speakList
    global brailleList
    if self.name:
      speakList.append(self.name.strip())
      brailleList.append(self.name.strip())

  @scriptHandler.script(
    gestures=("kb:upArrow", "kb:leftArrow", "KB:PageUp", "KB:HOME")
  )

  def script_PreviousElement(self, gesture):
    gesture.send()
    if not self.previous:
      baseDir = os.path.dirname(__file__).rsplit("\\",1)[0]
      fSound = os.path.join(baseDir, "globalPlugins", "OKO", "files", "sound", "STARTTXT.WAV")
      if os.path.isfile(fSound):
        winsound.PlaySound(fSound, winsound.SND_FILENAME)

  @scriptHandler.script(
    gestures=("kb:downArrow", "kb:rightArrow", "KB:PageDown", "KB:END")
  )

  def script_NextElement(self, gesture):
    gesture.send()
    if not self.next:
      baseDir = os.path.dirname(__file__).rsplit("\\",1)[0]
      fSound = os.path.join(baseDir, "globalPlugins", "OKO", "files", "sound", "STARTTXT.WAV")
      if os.path.isfile(fSound):
        winsound.PlaySound(fSound, winsound.SND_FILENAME)

